/////////////////////////////////////////////////////////
// ReflectYAxis effect
varying mediump vec2 vTex;
uniform lowp sampler2D samplerFront;

uniform lowp float pixelWidth;
uniform lowp float pixelHeight;
uniform lowp float OffsetY;
uniform mediump float gradientScale;
uniform mediump vec2 pixelSize;
uniform mediump vec2 srcEnd;
uniform mediump vec2 srcStart;
uniform mediump vec2 srcOriginStart;
uniform mediump vec2 srcOriginEnd;
uniform mediump vec2 layoutStart;
uniform mediump vec2 layoutEnd;
uniform lowp sampler2D samplerBack;
uniform mediump vec2 destStart;
uniform mediump vec2 destEnd;

void main(void)
{	
	mediump vec2 tex = vTex;
	
	mediump vec2 n = (vTex - srcOriginStart) / (srcOriginEnd - srcOriginStart);
	// 'Reflect' tex.y coord around OffsetY
	tex.y = OffsetY - tex.y + OffsetY;
	mediump vec2 nInvert = (tex - srcOriginStart) / (srcOriginEnd - srcOriginStart);

	lowp vec4 backInvert = texture2D(samplerBack, mix(destStart, destEnd, nInvert));
	lowp vec4 back = texture2D(samplerBack, mix(destStart, destEnd, n));
	
	backInvert = (1.0 - gradientScale * n.y) * backInvert;

	// Only reflect below OffsetY, rest passes through
	lowp vec4 backFinal = (vTex.y < OffsetY) ? backInvert : back;
	
	gl_FragColor = backFinal;
	
}